Index: /LMDZ6/branches/cirrus/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 5202)
@@ -1112,6 +1112,13 @@
   TYPE(ctrl_out), SAVE :: o_tke = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'tke ', 'TKE', 'm2/s2', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_tke_shear = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'tke_shear ', 'TKE shear term', 'm2/s3', (/ ('', i=1, 10) /))  
+  TYPE(ctrl_out), SAVE :: o_tke_buoy = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'tke_buoy ', 'TKE buoyancy term', 'm2/s3', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_tke_trans = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'tke_trans ', 'TKE transport term', 'm2/s3', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_tke_dissip = ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'tke_dissip ', 'TKE DISSIPATION', 'm2/s3', (/ ('', i=1, 10) /))   
+    'tke_dissip ', 'TKE dissipation term', 'm2/s3', (/ ('', i=1, 10) /))
+
   TYPE(ctrl_out), SAVE :: o_tke_max = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'tke_max', 'TKE max', 'm2/s2',                                  &
@@ -1442,4 +1449,12 @@
   TYPE(ctrl_out), SAVE :: o_tau_strat_1020 = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
     'OD1020_strat_only', 'Stratospheric Aerosol Optical depth at 1020 nm ', '1', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_SAD_sulfate = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
+    'SAD_sulfate', 'SAD WET sulfate aerosols', 'cm2/cm3', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_reff_sulfate = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
+    'reff_sulfate', 'Effective radius of WET sulfate aerosols', 'cm', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_sulfmmr = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
+    'sulfMMR', 'Sulfate aerosol concentration (dry mass mixing ratio)', 'kg(H2SO4)/kg(air)', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_nd_mode(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_sulfmmr_mode(:)
 !--chemistry
   TYPE(ctrl_out), SAVE :: o_R2SO4 = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
@@ -1551,4 +1566,11 @@
   TYPE(ctrl_out), SAVE :: o_rneb = ctrl_out((/ 2, 5, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'rneb', 'Cloud fraction', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_cldfraliq = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'cldfraliq', 'Liquid fraction of the cloud', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_sigma2_icefracturb = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'sigma2_icefracturb', 'Variance of the diagnostic supersaturation distribution (icefrac_turb) [-]', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_mean_icefracturb = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'mean_icefracturb', 'Mean of the diagnostic supersaturation distribution (icefrac_turb) [-]', '-', (/ ('', i=1, 10) /))
+ 
   TYPE(ctrl_out), SAVE :: o_rnebjn = ctrl_out((/ 2, 5, 10, 10, 10, 10, 11, 11,11, 11/), &      
     'rnebjn', 'Cloud fraction in day', '-', (/ ('', i=1, 10) /))
@@ -1981,4 +2003,28 @@
   TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dtr_dry(:)
 
+#ifdef ISO
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtprecip(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtevap(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtevap_srf(:,:) ! ajout Camille 8 mai 2023
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtplul(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtpluc(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtovap(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtoliq(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtcond(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtrunoff_diag(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtdyn(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtldyn(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtvdf(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtcon(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtlsc(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxteva(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtajs(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtthe(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtch4(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtprod_nucl(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtcosmo(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtdecroiss(:)
+#endif
+
   TYPE(ctrl_out), SAVE :: o_rsu = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'rsu', 'SW upward radiation', 'W m-2', (/ ('', i=1, 10) /))
@@ -2064,4 +2110,9 @@
   TYPE(ctrl_out), SAVE :: o_runoff = ctrl_out((/ 1, 1, 10, 1, 10, 10, 11, 11, 11, 11/), &
     'runoff', 'Run-off rate land ice', 'kg/m2/s', (/ ('', i=1, 10) /))
+! SN add runoff_diag
+!#ifdef ISO
+  TYPE(ctrl_out), SAVE :: o_runoff_diag = ctrl_out((/ 1, 1, 10, 1, 10, 10, 11, 11, 11, 11/), &
+    'runoffland', 'Run-off rate land for bucket', 'kg/m2/s', (/ ('', i=1, 10) /))
+!#endif
   TYPE(ctrl_out), SAVE :: o_albslw3 = ctrl_out((/ 1, 1, 1, 1, 10, 10, 11, 11, 11, 11/), &
     'albslw3', 'Surface albedo LW3', '-', (/ ('', i=1, 10) /))
Index: /LMDZ6/branches/cirrus/libf/phylmd/phys_output_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/phys_output_mod.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/phylmd/phys_output_mod.F90	(revision 5202)
@@ -35,5 +35,5 @@
     USE iophy 
     USE dimphy
-    USE infotrac_phy, ONLY: nqtot, tracers, niso
+    USE infotrac_phy, ONLY: nqtot, tracers, niso, ntraciso=>ntiso
     USE strings_mod,  ONLY: maxlen
     USE ioipsl
@@ -49,4 +49,13 @@
     ! ug Pour les sorties XIOS
     USE wxios
+#ifdef CPP_StratAer
+   USE infotrac_phy, ONLY: nbtr_bin
+#endif
+#ifdef ISO
+    USE isotopes_mod, ONLY: isoName,iso_HTO
+#ifdef ISOTRAC
+    use isotrac_mod, only: index_zone,index_iso,strtrac
+#endif
+#endif
 
     IMPLICIT NONE
@@ -93,5 +102,5 @@
     CHARACTER(LEN=4), DIMENSION(nlevSTD)  :: clevSTD
     REAL, DIMENSION(nlevSTD)              :: rlevSTD
-    INTEGER                               :: nsrf, k, iq, iff, i, j, ilev, itr, ixt, iiso, izone
+    INTEGER                               :: nsrf, k, iq, iff, i, j, ilev, itr, itrb, ixt, iiso, izone
     INTEGER                               :: naero
     LOGICAL                               :: ok_veget
@@ -112,4 +121,8 @@
     LOGICAL, DIMENSION(nfiles)            :: phys_out_filestations
 
+#ifdef ISO
+    CHARACTER(LEN=maxlen) :: outiso
+    CHARACTER(LEN=20) :: unit
+#endif
     CHARACTER(LEN=maxlen) :: tnam, lnam, dn
     INTEGER :: flag(nfiles)
@@ -158,4 +171,32 @@
     ALLOCATE(o_dtr_sscav(nqtot),o_dtr_sat(nqtot),o_dtr_uscav(nqtot))
     ALLOCATE(o_dtr_dry(nqtot),o_dtr_vdf(nqtot))
+#ifdef CPP_StratAer
+    ALLOCATE(o_nd_mode(nbtr_bin),o_sulfmmr_mode(nbtr_bin))
+#endif
+#ifdef ISO
+    ALLOCATE(o_xtprecip(ntraciso))
+    ALLOCATE(o_xtplul(ntraciso))
+    ALLOCATE(o_xtpluc(ntraciso))
+    ALLOCATE(o_xtevap(ntraciso))
+    ALLOCATE(o_xtevap_srf(ntraciso,4))
+    ALLOCATE(o_xtovap(ntraciso))
+    ALLOCATE(o_xtoliq(ntraciso))
+    ALLOCATE(o_xtcond(ntraciso))
+    ALLOCATE(o_xtrunoff_diag(ntraciso))
+    ALLOCATE(o_dxtdyn(ntraciso))
+    ALLOCATE(o_dxtldyn(ntraciso))
+    ALLOCATE(o_dxtcon(ntraciso))
+    ALLOCATE(o_dxtlsc(ntraciso))
+    ALLOCATE(o_dxteva(ntraciso))
+    ALLOCATE(o_dxtajs(ntraciso))
+    ALLOCATE(o_dxtvdf(ntraciso))
+    ALLOCATE(o_dxtthe(ntraciso))
+    ALLOCATE(o_dxtch4(ntraciso))
+    if (iso_HTO.gt.0) then
+      ALLOCATE(o_dxtprod_nucl(ntraciso))
+      ALLOCATE(o_dxtcosmo(ntraciso))
+      ALLOCATE(o_dxtdecroiss(ntraciso))
+    endif
+#endif
 
     levmax = [klev, klev, klev, klev, klev, klev, nlevSTD, nlevSTD, nlevSTD, klev]
@@ -467,5 +508,5 @@
      ENDIF ! clef_files
 
-          itr = 0
+          itr = 0; itrb = 0
           DO iq = 1, nqtot 
             IF(.NOT.(tracers(iq)%isAdvected .AND. tracers(iq)%isInPhysics)) CYCLE
@@ -503,9 +544,74 @@
             lnam = 'Cumulated tracer '//TRIM(tracers(iq)%longName)
             tnam = 'cum'//TRIM(tracers(iq)%name); o_trac_cum(itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-          ENDDO
+            
+#ifdef CPP_StratAer
+            if(tracers(iq)%name(1:3)=='BIN') then
+               itrb = itrb + 1
+               flag = [11, 11, 11, 11, 11, 11, 11, 11, 11, 1]
+               lnam = 'Dry particle concentration in '//TRIM(tracers(iq)%longName)
+               tnam = TRIM(tracers(iq)%name)//'_nd_mode';     o_nd_mode       (itrb) = ctrl_out(flag, tnam, lnam, "part/m3", [('',i=1,nfiles)])
+               lnam = 'Sulfate MMR in '//TRIM(tracers(iq)%longName)
+               tnam = TRIM(tracers(iq)%name)//'_sulfmmr_mode';o_sulfmmr_mode  (itrb) = ctrl_out(flag, tnam, lnam, "kg(H2SO4)/kg(air)", [('',i=1,nfiles)])
+            endif
+#endif
+         ENDDO
 
    ENDDO !  iff
 
-    ! Updated write frequencies due to phys_out_filetimesteps. 
+#ifdef ISO
+    write(*,*) 'phys_output_mid 589'
+    do ixt=1,ntraciso
+      outiso = TRIM(isoName(ixt))
+      i = INDEX(outiso, '_', .TRUE.)
+      outiso = outiso(1:i-1)//outiso(i+1:LEN_TRIM(outiso))
+
+      flag = [1,  1,  1, 10,  5, 10, 11, 11, 11, 11]; unit = 'kg/(s*m2)'
+      o_xtprecip(ixt)=ctrl_out(flag, 'precip'//TRIM(outiso), 'Precip Totale liq+sol', unit, [('',i=1,nfiles)])
+      o_xtpluc  (ixt)=ctrl_out(flag,   'pluc'//TRIM(outiso),    'Convective Precip.', unit, [('',i=1,nfiles)])
+
+      flag = [1,  1,  1, 10, 10, 10, 11, 11, 11, 11]
+      o_xtplul  (ixt)=ctrl_out(flag,   'plul'//TRIM(outiso),   'Large-scale Precip.', unit, [('',i=1,nfiles)])
+      o_xtevap  (ixt)=ctrl_out(flag,   'evap'//TRIM(outiso),             'Evaporat.', unit, [('',i=1,nfiles)])
+
+      ! ajout Camille 8 mai 2023
+      flag = [1, 6, 10, 10, 10, 10, 11, 11, 11, 11]
+      o_xtevap_srf (ixt,1)=ctrl_out(flag,   'evap_ter'//TRIM(outiso), 'Evap sfc'//clnsurf(1), unit, [('',i=1,nfiles)])
+      o_xtevap_srf (ixt,2)=ctrl_out(flag,   'evap_lic'//TRIM(outiso), 'Evap sfc'//clnsurf(2), unit, [('',i=1,nfiles)])
+      o_xtevap_srf (ixt,3)=ctrl_out(flag,   'evap_oce'//TRIM(outiso), 'Evap sfc'//clnsurf(3), unit, [('',i=1,nfiles)])
+      o_xtevap_srf (ixt,4)=ctrl_out(flag,   'evap_sic'//TRIM(outiso), 'Evap sfc'//clnsurf(4), unit, [('',i=1,nfiles)])
+
+      flag = [2,  3,  4, 10, 10, 10, 11, 11, 11, 11]; unit = 'kg/kg'
+      o_xtovap  (ixt)=ctrl_out(flag,   'ovap'//TRIM(outiso),     'Specific humidity', unit, [('',i=1,nfiles)])
+      o_xtoliq  (ixt)=ctrl_out(flag,   'oliq'//TRIM(outiso),          'Liquid water', unit, [('',i=1,nfiles)])
+      o_xtcond  (ixt)=ctrl_out(flag,  'ocond'//TRIM(outiso),       'Condensed water', unit, [('',i=1,nfiles)])
+
+      flag = [1,  1,  1, 10, 5, 10, 11, 11, 11, 11]; unit = 'kg/m2/s'
+      o_xtrunoff_diag  (ixt)=ctrl_out(flag, 'runoffland'//TRIM(outiso), 'Run-off rate land for bucket', unit, [('',i=1,nfiles)])
+
+      flag = [4, 10, 10, 10, 10, 10, 11, 11, 11, 11]; unit = '(kg/kg)/s'
+      o_dxtdyn  (ixt)=ctrl_out(flag,  'dqdyn'//TRIM(outiso),           'Dynamics dQ', unit, [('',i=1,nfiles)])
+      o_dxtldyn (ixt)=ctrl_out(flag, 'dqldyn'//TRIM(outiso),          'Dynamics dQL', unit, [('',i=1,nfiles)])
+      o_dxtcon  (ixt)=ctrl_out(flag,  'dqcon'//TRIM(outiso),         'Convection dQ', unit, [('',i=1,nfiles)])
+      o_dxteva  (ixt)=ctrl_out(flag,  'dqeva'//TRIM(outiso),      'Reevaporation dQ', unit, [('',i=1,nfiles)])
+      o_dxtlsc  (ixt)=ctrl_out(flag,  'dqlsc'//TRIM(outiso),       'Condensation dQ', unit, [('',i=1,nfiles)])
+      o_dxtajs  (ixt)=ctrl_out(flag,  'dqajs'//TRIM(outiso),        'Dry adjust. dQ', unit, [('',i=1,nfiles)])
+      o_dxtvdf  (ixt)=ctrl_out(flag,  'dqvdf'//TRIM(outiso),     'Boundary-layer dQ', unit, [('',i=1,nfiles)])
+      o_dxtthe  (ixt)=ctrl_out(flag,  'dqthe'//TRIM(outiso),            'Thermal dQ', unit, [('',i=1,nfiles)])
+
+      IF(ok_qch4) o_dxtch4(ixt)=ctrl_out(flag, 'dqch4'//TRIM(outiso), 'H2O due to CH4 oxidation & photolysis', &
+                                                                                      unit, [('',i=1,nfiles)])
+      IF(ixt == iso_HTO) THEN
+      o_dxtprod_nucl(ixt)=ctrl_out(flag, 'dqprodnucl'//TRIM(outiso), 'dHTO/dt due to nuclear production',      &
+                                                                                      unit, [('',i=1,nfiles)])
+      o_dxtcosmo    (ixt)=ctrl_out(flag,    'dqcosmo'//TRIM(outiso), 'dHTO/dt due to cosmogenic production',   &
+                                                                                      unit, [('',i=1,nfiles)])
+      o_dxtdecroiss (ixt)=ctrl_out(flag, 'dqdecroiss'//TRIM(outiso), 'dHTO/dt due to radiative destruction',   &
+                                                                                      unit, [('',i=1,nfiles)])
+      END IF
+    enddo !do ixt=1,niso
+    write(*,*) 'phys_output_mid 596'
+#endif
+
+   ! Updated write frequencies due to phys_out_filetimesteps. 
     ! Write frequencies are now in seconds.  
     ecrit_mth = ecrit_files(1)
Index: /LMDZ6/branches/cirrus/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/phys_output_write_mod.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/phylmd/phys_output_write_mod.F90	(revision 5202)
@@ -65,5 +65,6 @@
          o_fder, o_ffonte, o_fqcalving, o_fqfonte, o_mrroli, o_runofflic, &
          o_taux, o_tauy, o_snowsrf, o_qsnow, &
-         o_snowhgt, o_toice, o_sissnow, o_runoff, &
+! SN runoff_diag
+         o_snowhgt, o_toice, o_sissnow, o_runoff, o_runoff_diag, &
          o_albslw3, o_pourc_srf, o_fract_srf, &
          o_taux_srf, o_tauy_srf, o_tsol_srf, &
@@ -141,5 +142,5 @@
          o_zfull, o_zhalf, o_rneb, o_rnebjn, o_rnebcon, &
          o_rnebls, o_rneblsvol, o_rhum, o_rhl, o_rhi, o_ozone, o_ozone_light, &
-         o_pfraclr, o_pfracld, &
+         o_pfraclr, o_pfracld, o_cldfraliq, o_sigma2_icefracturb, o_mean_icefracturb,  &
          o_qrainlsc, o_qsnowlsc, o_dqreva, o_dqrauto, o_dqrcol, o_dqrmelt, o_dqrfreez, &
          o_dqssub, o_dqsauto, o_dqsagg, o_dqsrim, o_dqsmelt, o_dqsfreez, &
@@ -147,5 +148,5 @@
          o_dqsphy, o_dqsphy2d, o_dqbsphy, o_dqbsphy2d, o_albe_srf, o_z0m_srf, o_z0h_srf, &
          o_ages_srf, o_snow_srf, o_alb1, o_alb2, o_tke, o_tke_dissip, &
-         o_tke_max, o_kz, o_kz_max, o_clwcon, &
+         o_tke_max, o_kz, o_kz_max, o_clwcon, o_tke_shear, o_tke_buoy, o_tke_trans,  &
          o_dtdyn, o_dqdyn, o_dqdyn2d, o_dqldyn, o_dqldyn2d, & 
          o_dqsdyn, o_dqsdyn2d, o_dqbsdyn, o_dqbsdyn2d, o_dudyn, o_dvdyn, &
@@ -208,4 +209,5 @@
 ! Isotopes
          o_xtprecip,o_xtplul,o_xtpluc,o_xtovap,o_xtoliq,o_xtcond, &
+         o_xtrunoff_diag, &
          o_xtevap,o_dxtdyn,o_dxtldyn,o_dxtcon,o_dxtlsc,o_dxteva, &
          o_dxtajs,o_dxtvdf,o_dxtthe, o_dxtch4, &
@@ -248,4 +250,5 @@
 
 #ifdef CPP_StratAer
+    USE infotrac_phy, ONLY: nbtr_bin
     USE phys_output_ctrlout_mod, ONLY:  & 
          o_budg_3D_nucl, o_budg_3D_cond_evap, o_budg_3D_ocs_to_so2, o_budg_3D_so2_to_h2so4, &
@@ -259,5 +262,6 @@
          o_budg_ocs_to_so2, o_budg_so2_to_h2so4, o_budg_h2so4_to_part, &
          o_surf_PM25_sulf, o_ext_strat_550, o_tau_strat_550, &
-         o_vsed_aer, o_tau_strat_1020, o_ext_strat_1020, o_f_r_wet
+         o_vsed_aer, o_tau_strat_1020, o_ext_strat_1020, o_f_r_wet, &
+         o_SAD_sulfate, o_reff_sulfate, o_sulfmmr, o_nd_mode, o_sulfmmr_mode
 #endif
 
@@ -314,10 +318,11 @@
          zn2mout, t2m_min_mon, t2m_max_mon, evap, &
          snowerosion, zxustartlic, zxrhoslic, zxqsaltlic, &
-         l_mixmin,l_mix, pbl_eps, &
+         l_mixmin,l_mix, pbl_eps, tke_shear, tke_buoy, tke_trans, &
          zu10m, zv10m, zq2m, zustar, zxqsurf, &
          rain_lsc, rain_num, snow_lsc, bils, sens, fder, &
          zxffonte, zxfqcalving, zxfqfonte, zxrunofflic, fluxu, &
          fluxv, zxsnow, qsnow, snowhgt, to_ice, &
-         sissnow, runoff, albsol3_lic, evap_pot, &
+! SN runoff_diag
+         sissnow, runoff, runoff_diag, albsol3_lic, evap_pot, &
          t2m, fluxt, fluxlat, fsollw, fsolsw, &
          wfbils, wfevap, &
@@ -367,6 +372,7 @@
          ql_seri, qs_seri, qbs_seri, tr_seri, qbs_seri,&
          zphi, u_seri, v_seri, omega, cldfra, &
-         rneb, rnebjn, rneblsvol, zx_rh, zx_rhl, zx_rhi, &
-         pfraclr, pfracld,  &
+         rneb, rnebjn, rneblsvol,  &
+         zx_rh, zx_rhl, zx_rhi, &
+         pfraclr, pfracld, cldfraliq, sigma2_icefracturb, mean_icefracturb, &
          qraindiag, qsnowdiag, dqreva, dqssub, &
          dqrauto,dqrcol,dqrmelt,dqrfreez, &
@@ -382,5 +388,5 @@
          d_t_lscst, d_q_lscth, d_q_lscst, plul_th, &
          plul_st, d_t_vdf, d_t_diss, d_q_vdf, d_q_eva, &
-         d_t_bs, d_q_bs, d_qbs_bs, d_qbs_vdf, &
+         d_t_bsss, d_q_bsss, d_qbs_bsss, d_qbs_vdf, &
          zw2, fraca, zmax_th, d_q_ajsb, d_t_ec, d_u_vdf, &
          d_v_vdf, d_u_oro, d_v_oro, d_t_oro, d_u_lif, &
@@ -395,4 +401,5 @@
         d_xt_ajs, d_xt_ajsb, &
         d_xt_prod_nucl,d_xt_cosmo,d_xt_decroiss, &
+        xtrunoff_diag, &
 #endif
          ep, epmax_diag, &  ! epmax_cape
@@ -416,5 +423,6 @@
          budg_ocs_to_so2, budg_so2_to_h2so4, budg_h2so4_to_part, & 
          surf_PM25_sulf, tau_strat_550, tausum_strat, &
-         vsed_aer, tau_strat_1020, f_r_wet
+         vsed_aer, tau_strat_1020, f_r_wet, &
+         SAD_sulfate, reff_sulfate, sulfmmr, nd_mode, sulfmmr_mode
 #endif
 
@@ -449,5 +457,5 @@
     USE indice_sol_mod, ONLY: nbsrf
 #ifdef ISO
-    USE isotopes_mod, ONLY: iso_HTO
+    USE isotopes_mod, ONLY: iso_HTO, isoName
 #endif
     USE geometry_mod, ONLY: cell_area, latitude_deg, longitude_deg
@@ -530,4 +538,9 @@
     CHARACTER(LEN=maxlen) :: unt
 #endif
+
+#ifdef ISO
+    CHARACTER(LEN=maxlen) :: outiso
+#endif
+
     REAL,DIMENSION(klon,klev) :: z, dz
     REAL,DIMENSION(klon)      :: zrho, zt
@@ -1310,6 +1323,6 @@
 
        ENDDO
-       
-                
+
+
         IF (iflag_pbl > 1) THEN
           zx_tmp_fi3d=0.
@@ -1323,5 +1336,43 @@
           ENDIF
           
-          CALL histwrite_phy(o_tke_dissip, zx_tmp_fi3d)    
+          CALL histwrite_phy(o_tke_dissip, zx_tmp_fi3d)   
+
+          zx_tmp_fi3d=0.
+          IF (vars_defined) THEN
+             DO nsrf=1,nbsrf
+                DO k=1,klev
+                   zx_tmp_fi3d(:,k)=zx_tmp_fi3d(:,k) &
+                        +pctsrf(:,nsrf)*tke_shear(:,k,nsrf)
+                ENDDO
+             ENDDO
+          ENDIF
+
+          CALL histwrite_phy(o_tke_shear, zx_tmp_fi3d)
+
+          zx_tmp_fi3d=0.
+          IF (vars_defined) THEN
+             DO nsrf=1,nbsrf
+                DO k=1,klev
+                   zx_tmp_fi3d(:,k)=zx_tmp_fi3d(:,k) &
+                        +pctsrf(:,nsrf)*tke_buoy(:,k,nsrf)
+                ENDDO
+             ENDDO
+          ENDIF
+
+          CALL histwrite_phy(o_tke_buoy, zx_tmp_fi3d)
+
+
+          zx_tmp_fi3d=0.
+          IF (vars_defined) THEN
+             DO nsrf=1,nbsrf
+                DO k=1,klev
+                   zx_tmp_fi3d(:,k)=zx_tmp_fi3d(:,k) &
+                        +pctsrf(:,nsrf)*tke_trans(:,k,nsrf)
+                ENDDO
+             ENDDO
+          ENDIF
+
+          CALL histwrite_phy(o_tke_trans, zx_tmp_fi3d)
+
        ENDIF
 
@@ -1814,4 +1865,12 @@
           CALL histwrite_phy(o_tau_strat_550, tausum_strat(:,1))
           CALL histwrite_phy(o_tau_strat_1020, tausum_strat(:,2))
+          CALL histwrite_phy(o_SAD_sulfate, SAD_sulfate)
+          CALL histwrite_phy(o_reff_sulfate, reff_sulfate)
+          CALL histwrite_phy(o_sulfmmr, sulfmmr)
+          ! All BINs fields
+          DO itr = 1, nbtr_bin
+             CALL histwrite_phy(o_nd_mode(itr), nd_mode(:,:,itr))
+             CALL histwrite_phy(o_sulfmmr_mode(itr), sulfmmr_mode(:,:,itr))
+          ENDDO !--itr
        ENDIF
 #endif
@@ -2005,4 +2064,7 @@
            CALL histwrite_phy(o_pfraclr, pfraclr)
            CALL histwrite_phy(o_pfracld, pfracld)
+           CALL histwrite_phy(o_cldfraliq, cldfraliq)
+           CALL histwrite_phy(o_sigma2_icefracturb, sigma2_icefracturb)
+           CALL histwrite_phy(o_mean_icefracturb, mean_icefracturb)
            IF (ok_poprecip) THEN
            CALL histwrite_phy(o_qrainlsc, qraindiag)
@@ -2306,9 +2368,9 @@
           IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_qbs_vdf(1:klon,1:klev)/pdtphys
           CALL histwrite_phy(o_dqbsvdf, zx_tmp_fi3d)
-          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_qbs_bs(1:klon,1:klev)/pdtphys
+          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_qbs_bsss(1:klon,1:klev)/pdtphys
           CALL histwrite_phy(o_dqbsbs, zx_tmp_fi3d)
-          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_q_bs(1:klon,1:klev)/pdtphys
+          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_q_bsss(1:klon,1:klev)/pdtphys
           CALL histwrite_phy(o_dqbs, zx_tmp_fi3d)
-          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_t_bs(1:klon,1:klev)/pdtphys
+          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_t_bsss(1:klon,1:klev)/pdtphys
           CALL histwrite_phy(o_dtbs, zx_tmp_fi3d)
        ENDIF
@@ -2810,7 +2872,12 @@
        end if
 
+    !! runoff land bucket - ajout S. Nguyen 23 07 2024
+    CALL histwrite_phy(o_runoff_diag, runoff_diag)
+
 #ifdef ISO
-    do ixt=1,ntiso
-!        write(*,*) 'ixt'
+    !write(*,*) 'tmp phys_output_write: ntiso=',ntiso
+
+    DO ixt = 1, ntiso
+        !write(*,*) 'ixt,o_xtovap(ixt)=',ixt,o_xtovap(ixt)
         IF (vars_defined) zx_tmp_fi2d(:) = xtrain_fall(ixt,:) + xtsnow_fall(ixt,:)
         CALL histwrite_phy(o_xtprecip(ixt), zx_tmp_fi2d)
@@ -2824,4 +2891,8 @@
         CALL histwrite_phy(o_xtovap(ixt),  xt_seri(ixt,:,:))
         CALL histwrite_phy(o_xtoliq(ixt), xtl_seri(ixt,:,:))
+
+        !! runoff land bucket - ajout S. Nguyen 25 avril 2024
+        CALL histwrite_phy(o_xtrunoff_diag(ixt), xtrunoff_diag(ixt,:))
+
 
         DO nsrf = 1, nbsrf ! ajout Camille 8 mai 2023
@@ -2884,4 +2955,17 @@
           ENDDO !  iff
 #endif
+
+!SN activate water isotopes present in tracer.def
+#ifdef ISO
+          DO ixt = 1, ntiso
+            outiso = TRIM(isoName(ixt))
+            i = INDEX(outiso, '_', .TRUE.)
+            outiso = outiso(1:i-1)//outiso(i+1:LEN_TRIM(outiso))
+
+            CALL xios_set_fieldgroup_attr("iso2D_"//TRIM(outiso), enabled=.TRUE.)
+            CALL xios_set_fieldgroup_attr("iso3D_"//TRIM(outiso), enabled=.TRUE.)
+
+          ENDDO
+#endif
           !On finalise l'initialisation:
           IF (using_xios) CALL wxios_closedef()
Index: /LMDZ6/branches/cirrus/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/phys_state_var_mod.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/phylmd/phys_state_var_mod.F90	(revision 5202)
@@ -87,6 +87,7 @@
 !$OMP THREADPRIVATE(prw_ancien, prlw_ancien, prsw_ancien, prbsw_ancien)
 #ifdef ISO
-      REAL, ALLOCATABLE, SAVE :: xt_ancien(:,:,:),xtl_ancien(:,:,:),xts_ancien(:,:,:)
-!$OMP THREADPRIVATE(xt_ancien,xtl_ancien,xts_ancien)
+      REAL, ALLOCATABLE, SAVE :: xt_ancien(:,:,:),xtl_ancien(:,:,:),xts_ancien(:,:,:), &
+              xtbs_ancien(:,:,:)
+!$OMP THREADPRIVATE(xt_ancien,xtl_ancien,xts_ancien,xtbs_ancien)
 #endif
       REAL, ALLOCATABLE, SAVE :: u_ancien(:,:), v_ancien(:,:)
@@ -760,4 +761,5 @@
       ALLOCATE(xtl_ancien(ntraciso,klon,klev))
       ALLOCATE(xts_ancien(ntraciso,klon,klev))
+      ALLOCATE(xtbs_ancien(ntraciso,klon,klev))
       ALLOCATE(xtrain_fall(ntraciso,klon))
       ALLOCATE(xtsnow_fall(ntraciso,klon))
@@ -950,5 +952,5 @@
 #ifdef ISO    
       DEALLOCATE(xtsol,fxtevap)  
-      DEALLOCATE(xt_ancien,xtl_ancien,xts_ancien, fxtd, wake_deltaxt)
+      DEALLOCATE(xt_ancien,xtl_ancien,xts_ancien,xtbs_ancien, fxtd, wake_deltaxt)
       DEALLOCATE(xtrain_fall, xtsnow_fall, xtrain_con, xtsnow_con)
 #ifdef ISOTRAC 
